Index: kernel/generic/src/lib/func.c
===================================================================
--- kernel/generic/src/lib/func.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
+++ kernel/generic/src/lib/func.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -0,0 +1,82 @@
+/*
+ * Copyright (c) 2001-2004 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup generic
+ * @{
+ */
+
+/**
+ * @file
+ * @brief Miscellaneous functions.
+ */
+
+#include <func.h>
+#include <log.h>
+#include <cpu.h>
+#include <arch/asm.h>
+#include <arch.h>
+#include <console/kconsole.h>
+
+atomic_t haltstate = {0}; /**< Halt flag */
+
+
+/** Halt wrapper
+ *
+ * Set halt flag and halt the CPU.
+ *
+ */
+void halt(void)
+{
+#if (defined(CONFIG_DEBUG)) && (defined(CONFIG_KCONSOLE))
+	bool rundebugger = false;
+	
+	if (!atomic_get(&haltstate)) {
+		atomic_set(&haltstate, 1);
+		rundebugger = true;
+	}
+#else
+	atomic_set(&haltstate, 1);
+#endif
+	
+	interrupts_disable();
+	
+#if (defined(CONFIG_DEBUG)) && (defined(CONFIG_KCONSOLE))
+	if ((rundebugger) && (kconsole_check_poll()))
+		kconsole("panic", "\nLast resort kernel console ready.\n", false);
+#endif
+	
+	if (CPU)
+		log(LF_OTHER, LVL_NOTE, "cpu%u: halted", CPU->id);
+	else
+		log(LF_OTHER, LVL_NOTE, "cpu: halted");
+	
+	cpu_halt();
+}
+
+/** @}
+ */
Index: kernel/generic/src/lib/str.c
===================================================================
--- kernel/generic/src/lib/str.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/lib/str.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -217,5 +217,5 @@
  *         code was invalid.
  */
-errno_t chr_encode(const wchar_t ch, char *str, size_t *offset, size_t size)
+int chr_encode(const wchar_t ch, char *str, size_t *offset, size_t size)
 {
 	if (*offset >= size)
@@ -794,5 +794,5 @@
  *
  */
-static errno_t str_uint(const char *nptr, char **endptr, unsigned int base,
+static int str_uint(const char *nptr, char **endptr, unsigned int base,
     bool *neg, uint64_t *result)
 {
@@ -915,5 +915,5 @@
  *
  */
-errno_t str_uint64_t(const char *nptr, char **endptr, unsigned int base,
+int str_uint64_t(const char *nptr, char **endptr, unsigned int base,
     bool strict, uint64_t *result)
 {
@@ -922,5 +922,5 @@
 	bool neg;
 	char *lendptr;
-	errno_t ret = str_uint(nptr, &lendptr, base, &neg, result);
+	int ret = str_uint(nptr, &lendptr, base, &neg, result);
 	
 	if (endptr != NULL)
Index: kernel/generic/src/log/log.c
===================================================================
--- kernel/generic/src/log/log.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/log/log.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -221,7 +221,7 @@
 		
 		size_t buffer_offset = 0;
-		errno_t rc = chr_encode(wstr[chars], buffer, &buffer_offset, 16);
+		int rc = chr_encode(wstr[chars], buffer, &buffer_offset, 16);
 		if (rc != EOK) {
-			return EOF;
+			return rc;
 		}
 		
@@ -293,12 +293,12 @@
  *
  */
-sys_errno_t sys_klog(sysarg_t operation, void *buf, size_t size,
-    sysarg_t level, size_t *uspace_nread)
+sysarg_t sys_klog(sysarg_t operation, void *buf, size_t size,
+    sysarg_t level)
 {
 	char *data;
-	errno_t rc;
+	int rc;
 	
 	if (size > PAGE_SIZE)
-		return (sys_errno_t) ELIMIT;
+		return (sysarg_t) ELIMIT;
 	
 	switch (operation) {
@@ -306,10 +306,10 @@
 			data = (char *) malloc(size + 1, 0);
 			if (!data)
-				return (sys_errno_t) ENOMEM;
+				return (sysarg_t) ENOMEM;
 			
 			rc = copy_from_uspace(data, buf, size);
 			if (rc) {
 				free(data);
-				return (sys_errno_t) rc;
+				return (sysarg_t) rc;
 			}
 			data[size] = 0;
@@ -325,5 +325,5 @@
 			data = (char *) malloc(size, 0);
 			if (!data)
-				return (sys_errno_t) ENOMEM;
+				return (sysarg_t) ENOMEM;
 			
 			size_t entry_len = 0;
@@ -366,5 +366,5 @@
 			if (rc != EOK) {
 				free(data);
-				return (sys_errno_t) rc;
+				return (sysarg_t) rc;
 			}
 			
@@ -374,10 +374,9 @@
 			
 			if (rc != EOK)
-				return (sys_errno_t) rc;
-			
-			return copy_to_uspace(uspace_nread, &copied, sizeof(copied));
-			return EOK;
+				return (sysarg_t) rc;
+			
+			return copied;
 		default:
-			return (sys_errno_t) ENOTSUP;
+			return (sysarg_t) ENOTSUP;
 	}
 }
Index: kernel/generic/src/main/kinit.c
===================================================================
--- kernel/generic/src/main/kinit.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/main/kinit.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -51,5 +51,5 @@
 #include <proc/program.h>
 #include <panic.h>
-#include <halt.h>
+#include <func.h>
 #include <cpu.h>
 #include <arch/asm.h>
@@ -253,5 +253,5 @@
 		assert(page);
 		
-		errno_t rc = program_create_from_image((void *) page, namebuf,
+		int rc = program_create_from_image((void *) page, namebuf,
 		    &programs[i]);
 		
@@ -290,6 +290,6 @@
 			log(LF_OTHER, LVL_ERROR,
 			    "init[%zu]: Init binary load failed "
-			    "(error %s, loader status %u)", i,
-			    str_error_name(rc), programs[i].loader_status);
+			    "(error %d, loader status %u)", i, rc,
+			    programs[i].loader_status);
 	}
 	
Index: kernel/generic/src/main/main.c
===================================================================
--- kernel/generic/src/main/main.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/main/main.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -67,5 +67,4 @@
 #include <align.h>
 #include <interrupt.h>
-#include <str.h>
 #include <mm/frame.h>
 #include <mm/page.h>
Index: kernel/generic/src/main/shutdown.c
===================================================================
--- kernel/generic/src/main/shutdown.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/main/shutdown.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -38,5 +38,5 @@
 #include <arch.h>
 #include <proc/task.h>
-#include <halt.h>
+#include <func.h>
 #include <print.h>
 #include <log.h>
Index: kernel/generic/src/mm/as.c
===================================================================
--- kernel/generic/src/mm/as.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/mm/as.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -111,5 +111,5 @@
 as_t *AS_KERNEL = NULL;
 
-NO_TRACE static errno_t as_constructor(void *obj, unsigned int flags)
+NO_TRACE static int as_constructor(void *obj, unsigned int flags)
 {
 	as_t *as = (as_t *) obj;
@@ -760,5 +760,5 @@
  *
  */
-errno_t as_area_resize(as_t *as, uintptr_t address, size_t size, unsigned int flags)
+int as_area_resize(as_t *as, uintptr_t address, size_t size, unsigned int flags)
 {
 	if (!IS_ALIGNED(address, PAGE_SIZE))
@@ -833,5 +833,5 @@
 			    btree_node_t, leaf_link);
 			
-			if ((cond = (node->keys != 0))) {
+			if ((cond = (bool) node->keys)) {
 				uintptr_t ptr = node->key[node->keys - 1];
 				size_t node_size =
@@ -969,5 +969,5 @@
  *
  */
-errno_t as_area_destroy(as_t *as, uintptr_t address)
+int as_area_destroy(as_t *as, uintptr_t address)
 {
 	mutex_lock(&as->lock);
@@ -1085,5 +1085,5 @@
  *
  */
-errno_t as_area_share(as_t *src_as, uintptr_t src_base, size_t acc_size,
+int as_area_share(as_t *src_as, uintptr_t src_base, size_t acc_size,
     as_t *dst_as, unsigned int dst_flags_mask, uintptr_t *dst_base,
     uintptr_t bound)
@@ -1248,5 +1248,5 @@
  *
  */
-errno_t as_area_change_flags(as_t *as, unsigned int flags, uintptr_t address)
+int as_area_change_flags(as_t *as, unsigned int flags, uintptr_t address)
 {
 	/* Flags for the new memory mapping */
@@ -2208,17 +2208,17 @@
 }
 
-sys_errno_t sys_as_area_resize(uintptr_t address, size_t size, unsigned int flags)
-{
-	return (sys_errno_t) as_area_resize(AS, address, size, 0);
-}
-
-sys_errno_t sys_as_area_change_flags(uintptr_t address, unsigned int flags)
-{
-	return (sys_errno_t) as_area_change_flags(AS, flags, address);
-}
-
-sys_errno_t sys_as_area_destroy(uintptr_t address)
-{
-	return (sys_errno_t) as_area_destroy(AS, address);
+sysarg_t sys_as_area_resize(uintptr_t address, size_t size, unsigned int flags)
+{
+	return (sysarg_t) as_area_resize(AS, address, size, 0);
+}
+
+sysarg_t sys_as_area_change_flags(uintptr_t address, unsigned int flags)
+{
+	return (sysarg_t) as_area_change_flags(AS, flags, address);
+}
+
+sysarg_t sys_as_area_destroy(uintptr_t address)
+{
+	return (sysarg_t) as_area_destroy(AS, address);
 }
 
Index: kernel/generic/src/mm/backend_user.c
===================================================================
--- kernel/generic/src/mm/backend_user.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/mm/backend_user.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -49,5 +49,4 @@
 #include <errno.h>
 #include <log.h>
-#include <str.h>
 
 static bool user_create(as_area_t *);
@@ -126,11 +125,11 @@
 	IPC_SET_ARG5(data, pager_info->id3);
 
-	errno_t rc = ipc_req_internal(pager_info->pager, &data, (sysarg_t) true);
+	int rc = ipc_req_internal(pager_info->pager, &data, (sysarg_t) true);
 
 	if (rc != EOK) {
 		log(LF_USPACE, LVL_FATAL,
 		    "Page-in request for page %#" PRIxPTR
-		    " at pager %d failed with error %s.",
-		    upage, pager_info->pager, str_error_name(rc));
+		    " at pager %d failed with error %d.",
+		    upage, pager_info->pager, rc);
 		return AS_PF_FAULT;
 	}
Index: kernel/generic/src/mm/page.c
===================================================================
--- kernel/generic/src/mm/page.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/mm/page.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -190,5 +190,5 @@
 }
 
-errno_t page_find_mapping(uintptr_t virt, uintptr_t *phys)
+int page_find_mapping(uintptr_t virt, uintptr_t *phys)
 {
 	page_table_lock(AS, true);
@@ -215,13 +215,13 @@
  *
  */
-sys_errno_t sys_page_find_mapping(uintptr_t virt, uintptr_t *phys_ptr)
+sysarg_t sys_page_find_mapping(uintptr_t virt, uintptr_t *phys_ptr)
 {
 	uintptr_t phys;
-	errno_t rc = page_find_mapping(virt, &phys);
+	int rc = page_find_mapping(virt, &phys);
 	if (rc != EOK)
 		return rc;
 	
 	rc = copy_to_uspace(phys_ptr, &phys, sizeof(phys));
-	return (sys_errno_t) rc;
+	return (sysarg_t) rc;
 }
 
Index: kernel/generic/src/mm/slab.c
===================================================================
--- kernel/generic/src/mm/slab.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/mm/slab.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -102,5 +102,4 @@
 
 #include <assert.h>
-#include <errno.h>
 #include <synch/spinlock.h>
 #include <mm/slab.h>
@@ -335,5 +334,5 @@
 	irq_spinlock_unlock(&cache->slablock, true);
 	
-	if ((cache->constructor) && (cache->constructor(obj, flags) != EOK)) {
+	if ((cache->constructor) && (cache->constructor(obj, flags))) {
 		/* Bad, bad, construction failed */
 		slab_obj_destroy(cache, obj, slab);
@@ -608,5 +607,5 @@
  */
 NO_TRACE static void _slab_cache_create(slab_cache_t *cache, const char *name,
-    size_t size, size_t align, errno_t (*constructor)(void *obj,
+    size_t size, size_t align, int (*constructor)(void *obj,
     unsigned int kmflag), size_t (*destructor)(void *obj), unsigned int flags)
 {
@@ -662,5 +661,5 @@
  */
 slab_cache_t *slab_cache_create(const char *name, size_t size, size_t align,
-    errno_t (*constructor)(void *obj, unsigned int kmflag),
+    int (*constructor)(void *obj, unsigned int kmflag),
     size_t (*destructor)(void *obj), unsigned int flags)
 {
Index: kernel/generic/src/proc/program.c
===================================================================
--- kernel/generic/src/proc/program.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/proc/program.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -66,8 +66,8 @@
  * @param prg        Buffer for storing program information.
  *
- * @return EOK on success or an error code.
- *
- */
-errno_t program_create(as_t *as, uintptr_t entry_addr, char *name, program_t *prg)
+ * @return EOK on success or negative error code.
+ *
+ */
+int program_create(as_t *as, uintptr_t entry_addr, char *name, program_t *prg)
 {
 	prg->loader_status = EE_OK;
@@ -134,8 +134,8 @@
  *                        will be returned.
  *
- * @return EOK on success or an error code.
- *
- */
-errno_t program_create_from_image(void *image_addr, char *name, program_t *prg)
+ * @return EOK on success or negative error code.
+ *
+ */
+int program_create_from_image(void *image_addr, char *name, program_t *prg)
 {
 	as_t *as = as_create(0);
@@ -171,8 +171,8 @@
  * @param name Name to set for the program's task.
  *
- * @return EOK on success or an error code.
- *
- */
-errno_t program_create_loader(program_t *prg, char *name)
+ * @return EOK on success or negative error code.
+ *
+ */
+int program_create_loader(program_t *prg, char *name)
 {
 	as_t *as = as_create(0);
@@ -225,5 +225,5 @@
  *
  */
-sys_errno_t sys_program_spawn_loader(char *uspace_name, size_t name_len)
+sysarg_t sys_program_spawn_loader(char *uspace_name, size_t name_len)
 {
 	/* Cap length of name and copy it from userspace. */
@@ -232,7 +232,7 @@
 	
 	char namebuf[TASK_NAME_BUFLEN];
-	errno_t rc = copy_from_uspace(namebuf, uspace_name, name_len);
-	if (rc != EOK)
-		return (sys_errno_t) rc;
+	int rc = copy_from_uspace(namebuf, uspace_name, name_len);
+	if (rc != 0)
+		return (sysarg_t) rc;
 	
 	namebuf[name_len] = 0;
@@ -241,5 +241,5 @@
 	program_t prg;
 	rc = program_create_loader(&prg, namebuf);
-	if (rc != EOK)
+	if (rc != 0)
 		return rc;
 	
Index: kernel/generic/src/proc/scheduler.c
===================================================================
--- kernel/generic/src/proc/scheduler.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/proc/scheduler.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -58,5 +58,5 @@
 #include <context.h>
 #include <fpu_context.h>
-#include <halt.h>
+#include <func.h>
 #include <arch.h>
 #include <adt/list.h>
Index: kernel/generic/src/proc/task.c
===================================================================
--- kernel/generic/src/proc/task.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/proc/task.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -56,5 +56,5 @@
 #include <print.h>
 #include <errno.h>
-#include <halt.h>
+#include <func.h>
 #include <str.h>
 #include <syscall/copy.h>
@@ -83,5 +83,5 @@
 /* Forward declarations. */
 static void task_kill_internal(task_t *);
-static errno_t tsk_constructor(void *, unsigned int);
+static int tsk_constructor(void *, unsigned int);
 static size_t tsk_destructor(void *obj);
 
@@ -158,9 +158,9 @@
 }
 
-errno_t tsk_constructor(void *obj, unsigned int kmflags)
+int tsk_constructor(void *obj, unsigned int kmflags)
 {
 	task_t *task = (task_t *) obj;
 
-	errno_t rc = caps_task_alloc(task);
+	int rc = caps_task_alloc(task);
 	if (rc != EOK)
 		return rc;
@@ -185,5 +185,5 @@
 #endif
 	
-	return EOK;
+	return 0;
 }
 
@@ -207,8 +207,4 @@
 {
 	task_t *task = (task_t *) slab_alloc(task_cache, 0);
-	if (task == NULL) {
-		return NULL;
-	}
-	
 	task_create_arch(task);
 	
@@ -245,13 +241,5 @@
 	if ((ipc_phone_0) &&
 	    (container_check(ipc_phone_0->task->container, task->container))) {
-		cap_handle_t phone_handle;
-		errno_t rc = phone_alloc(task, &phone_handle);
-		if (rc != EOK) {
-			task->as = NULL;
-			task_destroy_arch(task);
-			slab_free(task_cache, task);
-			return NULL;
-		}
-		
+		cap_handle_t phone_handle = phone_alloc(task);
 		kobject_t *phone_obj = kobject_get(task, phone_handle,
 		    KOBJECT_TYPE_PHONE);
@@ -345,5 +333,5 @@
  *
  */
-sys_errno_t sys_task_get_id(sysarg64_t *uspace_taskid)
+sysarg_t sys_task_get_id(sysarg64_t *uspace_taskid)
 {
 	/*
@@ -351,5 +339,5 @@
 	 * the lifespan of the task.
 	 */
-	return (sys_errno_t) copy_to_uspace(uspace_taskid, &TASK->taskid,
+	return (sysarg_t) copy_to_uspace(uspace_taskid, &TASK->taskid,
 	    sizeof(TASK->taskid));
 }
@@ -385,5 +373,5 @@
  *
  */
-sys_errno_t sys_task_set_name(const char *uspace_name, size_t name_len)
+sysarg_t sys_task_set_name(const char *uspace_name, size_t name_len)
 {
 	char namebuf[TASK_NAME_BUFLEN];
@@ -393,7 +381,7 @@
 		name_len = TASK_NAME_BUFLEN - 1;
 	
-	errno_t rc = copy_from_uspace(namebuf, uspace_name, name_len);
-	if (rc != EOK)
-		return (sys_errno_t) rc;
+	int rc = copy_from_uspace(namebuf, uspace_name, name_len);
+	if (rc != 0)
+		return (sysarg_t) rc;
 	
 	namebuf[name_len] = '\0';
@@ -426,12 +414,12 @@
  *
  */
-sys_errno_t sys_task_kill(task_id_t *uspace_taskid)
+sysarg_t sys_task_kill(task_id_t *uspace_taskid)
 {
 	task_id_t taskid;
-	errno_t rc = copy_from_uspace(&taskid, uspace_taskid, sizeof(taskid));
-	if (rc != EOK)
-		return (sys_errno_t) rc;
-	
-	return (sys_errno_t) task_kill(taskid);
+	int rc = copy_from_uspace(&taskid, uspace_taskid, sizeof(taskid));
+	if (rc != 0)
+		return (sysarg_t) rc;
+	
+	return (sysarg_t) task_kill(taskid);
 }
 
@@ -539,5 +527,5 @@
  *
  */
-errno_t task_kill(task_id_t id)
+int task_kill(task_id_t id)
 {
 	if (id == 1)
@@ -596,5 +584,5 @@
  *
  */
-sys_errno_t sys_task_exit(sysarg_t notify)
+sysarg_t sys_task_exit(sysarg_t notify)
 {
 	task_kill_self(notify);
Index: kernel/generic/src/proc/thread.c
===================================================================
--- kernel/generic/src/proc/thread.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/proc/thread.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -153,5 +153,5 @@
  *
  */
-static errno_t thr_constructor(void *obj, unsigned int kmflags)
+static int thr_constructor(void *obj, unsigned int kmflags)
 {
 	thread_t *thread = (thread_t *) obj;
@@ -171,5 +171,5 @@
 	thread->saved_fpu_context = slab_alloc(fpu_context_cache, kmflags);
 	if (!thread->saved_fpu_context)
-		return ENOMEM;
+		return -1;
 #endif /* CONFIG_FPU_LAZY */
 #endif /* CONFIG_FPU */
@@ -201,5 +201,5 @@
 			slab_free(fpu_context_cache, thread->saved_fpu_context);
 #endif
-		return ENOMEM;
+		return -1;
 	}
 	
@@ -210,5 +210,5 @@
 #endif
 	
-	return EOK;
+	return 0;
 }
 
@@ -548,5 +548,5 @@
  * 
  * Threads that are blocked waiting for a synchronization primitive 
- * are woken up with a return code of EINTR if the
+ * are woken up with a return code of ESYNCH_INTERRUPTED if the
  * blocking call was interruptable. See waitq_sleep_timeout().
  * 
@@ -639,5 +639,5 @@
  *
  */
-errno_t thread_join_timeout(thread_t *thread, uint32_t usec, unsigned int flags)
+int thread_join_timeout(thread_t *thread, uint32_t usec, unsigned int flags)
 {
 	if (thread == THREAD)
@@ -653,5 +653,5 @@
 	irq_spinlock_unlock(&thread->lock, true);
 	
-	return waitq_sleep_timeout(&thread->join_wq, usec, flags, NULL);
+	return waitq_sleep_timeout(&thread->join_wq, usec, flags);
 }
 
@@ -700,5 +700,5 @@
 	waitq_initialize(&wq);
 	
-	(void) waitq_sleep_timeout(&wq, usec, SYNCH_FLAGS_NON_BLOCKING, NULL);
+	(void) waitq_sleep_timeout(&wq, usec, SYNCH_FLAGS_NON_BLOCKING);
 }
 
@@ -930,5 +930,5 @@
  *
  */
-sys_errno_t sys_thread_create(uspace_arg_t *uspace_uarg, char *uspace_name,
+sysarg_t sys_thread_create(uspace_arg_t *uspace_uarg, char *uspace_name,
     size_t name_len, thread_id_t *uspace_thread_id)
 {
@@ -937,7 +937,7 @@
 	
 	char namebuf[THREAD_NAME_BUFLEN];
-	errno_t rc = copy_from_uspace(namebuf, uspace_name, name_len);
-	if (rc != EOK)
-		return (sys_errno_t) rc;
+	int rc = copy_from_uspace(namebuf, uspace_name, name_len);
+	if (rc != 0)
+		return (sysarg_t) rc;
 	
 	namebuf[name_len] = 0;
@@ -951,7 +951,7 @@
 	
 	rc = copy_from_uspace(kernel_uarg, uspace_uarg, sizeof(uspace_arg_t));
-	if (rc != EOK) {
+	if (rc != 0) {
 		free(kernel_uarg);
-		return (sys_errno_t) rc;
+		return (sysarg_t) rc;
 	}
 	
@@ -962,5 +962,5 @@
 			rc = copy_to_uspace(uspace_thread_id, &thread->tid,
 			    sizeof(thread->tid));
-			if (rc != EOK) {
+			if (rc != 0) {
 				/*
 				 * We have encountered a failure, but the thread
@@ -977,5 +977,5 @@
 				free(kernel_uarg);
 				
-				return (sys_errno_t) rc;
+				return (sysarg_t) rc;
 			 }
 		}
@@ -999,5 +999,5 @@
 		free(kernel_uarg);
 	
-	return (sys_errno_t) ENOMEM;
+	return (sysarg_t) ENOMEM;
 }
 
@@ -1005,7 +1005,10 @@
  *
  */
-sys_errno_t sys_thread_exit(int uspace_status)
+sysarg_t sys_thread_exit(int uspace_status)
 {
 	thread_exit();
+	
+	/* Unreachable */
+	return 0;
 }
 
@@ -1018,5 +1021,5 @@
  *
  */
-sys_errno_t sys_thread_get_id(thread_id_t *uspace_thread_id)
+sysarg_t sys_thread_get_id(thread_id_t *uspace_thread_id)
 {
 	/*
@@ -1025,10 +1028,10 @@
 	 *
 	 */
-	return (sys_errno_t) copy_to_uspace(uspace_thread_id, &THREAD->tid,
+	return (sysarg_t) copy_to_uspace(uspace_thread_id, &THREAD->tid,
 	    sizeof(THREAD->tid));
 }
 
 /** Syscall wrapper for sleeping. */
-sys_errno_t sys_thread_usleep(uint32_t usec)
+sysarg_t sys_thread_usleep(uint32_t usec)
 {
 	thread_usleep(usec);
@@ -1036,5 +1039,5 @@
 }
 
-sys_errno_t sys_thread_udelay(uint32_t usec)
+sysarg_t sys_thread_udelay(uint32_t usec)
 {
 	delay(usec);
Index: kernel/generic/src/security/perm.c
===================================================================
--- kernel/generic/src/security/perm.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/security/perm.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -84,8 +84,8 @@
  *
  */
-static errno_t perm_grant(task_id_t taskid, perm_t perms)
+static sysarg_t perm_grant(task_id_t taskid, perm_t perms)
 {
 	if (!(perm_get(TASK) & PERM_PERM))
-		return EPERM;
+		return (sysarg_t) EPERM;
 	
 	irq_spinlock_lock(&tasks_lock, true);
@@ -94,5 +94,5 @@
 	if ((!task) || (!container_check(CONTAINER, task->container))) {
 		irq_spinlock_unlock(&tasks_lock, true);
-		return ENOENT;
+		return (sysarg_t) ENOENT;
 	}
 	
@@ -102,5 +102,5 @@
 	
 	irq_spinlock_unlock(&tasks_lock, true);
-	return EOK;
+	return 0;
 }
 
@@ -116,5 +116,5 @@
  *
  */
-static errno_t perm_revoke(task_id_t taskid, perm_t perms)
+static sysarg_t perm_revoke(task_id_t taskid, perm_t perms)
 {
 	irq_spinlock_lock(&tasks_lock, true);
@@ -123,5 +123,5 @@
 	if ((!task) || (!container_check(CONTAINER, task->container))) {
 		irq_spinlock_unlock(&tasks_lock, true);
-		return ENOENT;
+		return (sysarg_t) ENOENT;
 	}
 	
@@ -136,5 +136,5 @@
 		irq_spinlock_unlock(&TASK->lock, false);
 		irq_spinlock_unlock(&tasks_lock, true);
-		return EPERM;
+		return (sysarg_t) EPERM;
 	}
 	
@@ -143,5 +143,5 @@
 	
 	irq_spinlock_unlock(&tasks_lock, true);
-	return EOK;
+	return 0;
 }
 
@@ -158,10 +158,10 @@
  *
  */
-sys_errno_t sys_perm_grant(sysarg64_t *uspace_taskid, perm_t perms)
+sysarg_t sys_perm_grant(sysarg64_t *uspace_taskid, perm_t perms)
 {
 	sysarg64_t taskid;
-	errno_t rc = copy_from_uspace(&taskid, uspace_taskid, sizeof(sysarg64_t));
-	if (rc != EOK)
-		return (sys_errno_t) rc;
+	int rc = copy_from_uspace(&taskid, uspace_taskid, sizeof(sysarg64_t));
+	if (rc != 0)
+		return (sysarg_t) rc;
 	
 	return perm_grant((task_id_t) taskid, perms);
@@ -179,10 +179,10 @@
  *
  */
-sys_errno_t sys_perm_revoke(sysarg64_t *uspace_taskid, perm_t perms)
+sysarg_t sys_perm_revoke(sysarg64_t *uspace_taskid, perm_t perms)
 {
 	sysarg64_t taskid;
-	errno_t rc = copy_from_uspace(&taskid, uspace_taskid, sizeof(sysarg64_t));
-	if (rc != EOK)
-		return (sys_errno_t) rc;
+	int rc = copy_from_uspace(&taskid, uspace_taskid, sizeof(sysarg64_t));
+	if (rc != 0)
+		return (sysarg_t) rc;
 	
 	return perm_revoke((task_id_t) taskid, perms);
@@ -203,5 +203,5 @@
  *
  */
-sys_errno_t sys_perm_grant(sysarg_t taskid, perm_t perms)
+sysarg_t sys_perm_grant(sysarg_t taskid, perm_t perms)
 {
 	return perm_grant((task_id_t) taskid, perms);
@@ -219,5 +219,5 @@
  *
  */
-sys_errno_t sys_perm_revoke(sysarg_t taskid, perm_t perms)
+sysarg_t sys_perm_revoke(sysarg_t taskid, perm_t perms)
 {
 	return perm_revoke((task_id_t) taskid, perms);
Index: kernel/generic/src/synch/condvar.c
===================================================================
--- kernel/generic/src/synch/condvar.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/synch/condvar.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -80,14 +80,13 @@
  * For exact description of meaning of possible combinations of usec and flags,
  * see comment for waitq_sleep_timeout().  Note that when
- * SYNCH_FLAGS_NON_BLOCKING is specified here, EAGAIN is always
+ * SYNCH_FLAGS_NON_BLOCKING is specified here, ESYNCH_WOULD_BLOCK is always
  * returned.
  *
  * @return		See comment for waitq_sleep_timeout().
  */
-errno_t _condvar_wait_timeout(condvar_t *cv, mutex_t *mtx, uint32_t usec, int flags)
+int _condvar_wait_timeout(condvar_t *cv, mutex_t *mtx, uint32_t usec, int flags)
 {
-	errno_t rc;
+	int rc;
 	ipl_t ipl;
-	bool blocked;
 
 	ipl = waitq_sleep_prepare(&cv->wq);
@@ -96,8 +95,7 @@
 
 	cv->wq.missed_wakeups = 0;	/* Enforce blocking. */
-	rc = waitq_sleep_timeout_unsafe(&cv->wq, usec, flags, &blocked);
-	assert(blocked || rc != EOK);
+	rc = waitq_sleep_timeout_unsafe(&cv->wq, usec, flags);
 
-	waitq_sleep_finish(&cv->wq, blocked, ipl);
+	waitq_sleep_finish(&cv->wq, rc, ipl);
 	/* Lock only after releasing the waitq to avoid a possible deadlock. */
 	mutex_lock(mtx);
@@ -119,16 +117,15 @@
  * For exact description of meaning of possible combinations of usec and flags,
  * see comment for waitq_sleep_timeout().  Note that when
- * SYNCH_FLAGS_NON_BLOCKING is specified here, EAGAIN is always
+ * SYNCH_FLAGS_NON_BLOCKING is specified here, ESYNCH_WOULD_BLOCK is always
  * returned.
  *
  * @return See comment for waitq_sleep_timeout().
  */
-errno_t _condvar_wait_timeout_spinlock_impl(condvar_t *cv, spinlock_t *lock, 
+int _condvar_wait_timeout_spinlock_impl(condvar_t *cv, spinlock_t *lock, 
 	uint32_t usec, int flags)
 {
-	errno_t rc;
+	int rc;
 	ipl_t ipl;
-	bool blocked;
-
+	
 	ipl = waitq_sleep_prepare(&cv->wq);
 
@@ -137,8 +134,7 @@
 
 	cv->wq.missed_wakeups = 0;	/* Enforce blocking. */
-	rc = waitq_sleep_timeout_unsafe(&cv->wq, usec, flags, &blocked);
-	assert(blocked || rc != EOK);
+	rc = waitq_sleep_timeout_unsafe(&cv->wq, usec, flags);
 
-	waitq_sleep_finish(&cv->wq, blocked, ipl);
+	waitq_sleep_finish(&cv->wq, rc, ipl);
 	/* Lock only after releasing the waitq to avoid a possible deadlock. */
 	spinlock_lock(lock);
@@ -156,13 +152,13 @@
  * For exact description of meaning of possible combinations of usec and flags,
  * see comment for waitq_sleep_timeout().  Note that when
- * SYNCH_FLAGS_NON_BLOCKING is specified here, EAGAIN is always
+ * SYNCH_FLAGS_NON_BLOCKING is specified here, ESYNCH_WOULD_BLOCK is always
  * returned.
  *
  * @return See comment for waitq_sleep_timeout().
  */
-errno_t _condvar_wait_timeout_irq_spinlock(condvar_t *cv, irq_spinlock_t *irq_lock, 
+int _condvar_wait_timeout_irq_spinlock(condvar_t *cv, irq_spinlock_t *irq_lock, 
 	uint32_t usec, int flags)
 {
-	errno_t rc;
+	int rc;
 	/* Save spinlock's state so we can restore it correctly later on. */
 	ipl_t ipl = irq_lock->ipl;
Index: kernel/generic/src/synch/futex.c
===================================================================
--- kernel/generic/src/synch/futex.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/synch/futex.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -395,13 +395,13 @@
  *
  * @return		If there is no physical mapping for uaddr ENOENT is
- *			returned. Otherwise returns the return value of
- *                      waitq_sleep_timeout().
- */
-sys_errno_t sys_futex_sleep(uintptr_t uaddr)
+ *			returned. Otherwise returns a wait result as defined in
+ *			synch.h.
+ */
+sysarg_t sys_futex_sleep(uintptr_t uaddr)
 {
 	futex_t *futex = get_futex(uaddr);
 	
 	if (!futex) 
-		return (sys_errno_t) ENOENT;
+		return (sysarg_t) ENOENT;
 
 #ifdef CONFIG_UDEBUG
@@ -409,6 +409,5 @@
 #endif
 
-	errno_t rc = waitq_sleep_timeout(
-	    &futex->wq, 0, SYNCH_FLAGS_INTERRUPTIBLE, NULL);
+	int rc = waitq_sleep_timeout(&futex->wq, 0, SYNCH_FLAGS_INTERRUPTIBLE); 
 
 #ifdef CONFIG_UDEBUG
@@ -416,5 +415,5 @@
 #endif
 
-	return (sys_errno_t) rc;
+	return (sysarg_t) rc;
 }
 
@@ -425,5 +424,5 @@
  * @return		ENOENT if there is no physical mapping for uaddr.
  */
-sys_errno_t sys_futex_wakeup(uintptr_t uaddr)
+sysarg_t sys_futex_wakeup(uintptr_t uaddr)
 {
 	futex_t *futex = get_futex(uaddr);
@@ -431,7 +430,7 @@
 	if (futex) {
 		waitq_wakeup(&futex->wq, WAKEUP_FIRST);
-		return EOK;
+		return 0;
 	} else {
-		return (sys_errno_t) ENOENT;
+		return (sysarg_t) ENOENT;
 	}
 }
Index: kernel/generic/src/synch/mutex.c
===================================================================
--- kernel/generic/src/synch/mutex.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/synch/mutex.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -37,5 +37,4 @@
 
 #include <assert.h>
-#include <errno.h>
 #include <synch/mutex.h>
 #include <synch/semaphore.h>
@@ -85,7 +84,7 @@
  *
  */
-errno_t _mutex_lock_timeout(mutex_t *mtx, uint32_t usec, unsigned int flags)
+int _mutex_lock_timeout(mutex_t *mtx, uint32_t usec, unsigned int flags)
 {
-	errno_t rc;
+	int rc;
 
 	if (mtx->type == MUTEX_PASSIVE && THREAD) {
@@ -96,8 +95,8 @@
 		if (mtx->owner == THREAD) {
 			mtx->nesting++;
-			return EOK;
+			return ESYNCH_OK_ATOMIC;
 		} else {
 			rc = _semaphore_down_timeout(&mtx->sem, usec, flags);
-			if (rc == EOK) {
+			if (SYNCH_OK(rc)) {
 				mtx->owner = THREAD;
 				mtx->nesting = 1;
@@ -120,5 +119,6 @@
 			}
 			rc = semaphore_trydown(&mtx->sem);
-		} while (rc != EOK && !(flags & SYNCH_FLAGS_NON_BLOCKING));
+		} while (SYNCH_FAILED(rc) &&
+		    !(flags & SYNCH_FLAGS_NON_BLOCKING));
 		if (deadlock_reported)
 			printf("cpu%u: not deadlocked\n", CPU->id);
